package se.liu.ida.tddc77.felhantering;

import java.util.LinkedList;
import java.util.Stack;

public class Hanoi {
	//LinkedList kan också  användas.
	private final Stack<String> A = new Stack<String>();
	private final Stack<String> B = new Stack<String>();
	private final Stack<String> C = new Stack<String>();
	
	private int numberOfStacks;
	
	public Hanoi(int n) {
		this.numberOfStacks = n;
	}
	
	public void moveA2B(int n) {
		System.out.println("moveA2B: calling moveA2B  with " + n + "\nCurrent stacks:" + this);
		if (n > 0) {
			moveA2C(n-1);
			System.out.println("moveA2B: calling moveA2C  with " + (n-1) + "\nCurrent stacks:" + this);
			C.push(A.pop());
			System.out.println("moveA2B: after moving one element ");
			moveC2B(n-1);
			System.out.println("moveA2B: calling moveC2B  with " + (n-1) + "\nCurrent stacks:" + this);

		}
	}
	
	public void moveA2C(int n) {
		if (n > 0) {
			moveA2B(n-1);
			C.push(A.pop());
			moveB2C(n-1);
		}
	}
	
	public void moveB2C(int n) {
		if (n > 0) {
			moveB2A(n-1);
			System.out.println(this);
			C.push(B.pop());
			System.out.println(this);
			moveA2C(n-1);
		}
	}
	
	public void moveC2A(int n) {
		if (n > 0) {
			moveC2B(n-1);
			System.out.println(this);
			A.push(C.pop());
			System.out.println(this);
			moveB2A(n-1);
		}
	}
	
	public void moveB2A(int n) {
		if (n > 0) {
			moveB2C(n-1);
			System.out.println(this);
			A.push(B.pop());
			System.out.println(this);
			moveC2A(n-1);
		}
	}
	
	public void moveC2B(int n) {
		if (n > 0) {
			moveC2A(n-1);
			System.out.println(this);
			B.push(C.pop());
			System.out.println(this);
			moveA2B(n-1);
		}
	}
	
	

}
